VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsOpenFolder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" _
(ByVal lpString1 As String, ByVal lpString2 As String) As Long
Private Declare Function SHBrowseForFolder Lib "shell32" _
(lpbi As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" _
(ByVal pidList As Long, ByVal lpBuffer As String) As Long

Private Type BrowseInfo
   hwndOwner As Long
   pIDLRoot As Long
   pszDisplayName As Long
   lpszTitle As Long
   ulFlags As Long
   lpfnCallback As Long
   lParam As Long
   iImage As Long
End Type

Private Const BIF_RETURNONLYFSDIRS = &H1
'    Find
Private Const BIF_DONTGOBELOWDOMAIN = &H2
Private Const BIF_STATUSTEXT = &H4
Private Const BIF_RETURNFSANCESTORS = &H8
'  
Private Const BIF_BROWSEFORCOMPUTER = &H1000
'  
Private Const BIF_BROWSEFORPRINTER = &H2000
'  
Private Const BIF_BROWSEINCLUDEFILES = &H4000
'
'Private Const BIF_RETURNONLYFSDIRS = 1
Private Const MAX_PATH = 260

Private m_FolderName As String
Private m_Prompt As String
Private m_OwnerHwnd As Long
Private Function BrowseForFolder(m_OwnerHwnd As Long, m_Prompt As String) As Boolean

Dim iNull As Integer
Dim lpIDList As Long
Dim lResult As Long
Dim sPath As String
Dim udtBI As BrowseInfo

With udtBI
  '  
  .hwndOwner = m_OwnerHwnd
  '   
  .lpszTitle = lstrcat(m_Prompt, "")
  '  -    ...
  .ulFlags = BIF_RETURNONLYFSDIRS
End With

'  
lpIDList = SHBrowseForFolder(udtBI)

If lpIDList Then
  '   , ...
  sPath = String$(MAX_PATH, 0)
  '        ...
  lResult = SHGetPathFromIDList(lpIDList, sPath)
  Call CoTaskMemFree(lpIDList)
  iNull = InStr(sPath, vbNullChar)
  If iNull Then sPath = Left(sPath, iNull - 1)
End If

' ,   ...
If sPath <> "" Then
  '     ( )
  BrowseForFolder = True
  m_FolderName = sPath
Else
  '     Cancel
  BrowseForFolder = False
  m_FolderName = ""
End If

End Function

Public Property Let OwnerHwnd(ByVal vNewValue As Long)
  m_OwnerHwnd = vNewValue
End Property

Public Property Let DialogTitle(ByVal vNewValue As String)
  m_Prompt = vNewValue
End Property

Public Property Get FolderName()
  FolderName = m_FolderName
End Property

Public Function ShowOpenFolder() As Boolean
Attribute ShowOpenFolder.VB_Description = "   "
  ShowOpenFolder = BrowseForFolder(m_OwnerHwnd, m_Prompt)
End Function


